/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.api.blocks.banners;

import org.bukkit.DyeColor;

/**
 * @author tschuliaehn
 * @version 1.0
 */

public enum BannerColor {
    BLACK('0', DyeColor.BLACK),
    BLUE('1', DyeColor.BLUE),
    BROWN('g', DyeColor.BROWN),
    CYAN('3', DyeColor.CYAN),
    GRAY('8', DyeColor.GRAY),
    GREEN('2', DyeColor.GREEN),
    LIGHT_BLUE('b', DyeColor.LIGHT_BLUE),
    LIME('a', DyeColor.LIME),
    MAGENTA('c', DyeColor.MAGENTA),
    ORANGE('6', DyeColor.ORANGE),
    PINK('d', DyeColor.PINK),
    PURPLE('5', DyeColor.PURPLE),
    RED('4', DyeColor.RED),
    SILVER('7', DyeColor.SILVER),
    WHITE('f', DyeColor.WHITE),
    YELLOW('e', DyeColor.YELLOW);

    private char colorCode;
    private DyeColor color;
    public static final char COLORCODE = '§';
    public static final char FOREGROUND_COLORCODE = 'F';
    public static final char BACKGROUND_COLORCODE = 'B';

    private BannerColor(char colorCode, DyeColor color) {
        this.colorCode = colorCode;
        this.color = color;
    }

    public char getColorCode() {
        return this.colorCode;
    }

    public DyeColor getColor() {
        return this.color;
    }

    public static BannerColor translate(char color) {
        BannerColor[] arrayOfBannerColor;
        int j = (arrayOfBannerColor = values()).length;
        for (int i = 0; i < j; i++) {
            BannerColor colors = arrayOfBannerColor[i];
            if (colors.getColorCode() == color) {
                return colors;
            }
        }
        return WHITE;
    }

    public static final BannerColor NORMAL_FOREGROUND = WHITE;
    public static final BannerColor NORMAL_BACKGROUND = BLACK;
}
