/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.api.effects;

import eu.univento.core.Core;
import net.minecraft.server.v1_12_R1.EnumParticle;
import net.minecraft.server.v1_12_R1.PacketPlayOutWorldParticles;
import org.bukkit.Location;
import org.bukkit.craftbukkit.v1_12_R1.entity.CraftPlayer;
import org.bukkit.entity.Player;

/**
 * some better effects
 * @author joethei
 * @version 1.0
 */
public class Effects {
	
	/**
	 * plays effects from location
	 * @param loc Location
	 * @param ep EnumParticle
	 * @param count count of particles
	 */
	public static void playEffect(Location loc, EnumParticle ep, int count) {
		PacketPlayOutWorldParticles packet = new PacketPlayOutWorldParticles(ep, true, (float) loc.getX(), (float) loc.getY(), (float) loc.getZ(), (float) 5, (float) 5, (float) 5, 0.0F, count, 0, 0);
		Core.getOnlinePlayers().stream().filter(players -> players.getDatabasePlayer().getSettings().hasEffectsEnabled()).forEach(players -> players.sendPacket(packet));
	}

    public static void playEffectToPlayer(Player p, Location loc, EnumParticle ep, float f, int count) {
        PacketPlayOutWorldParticles packet = new PacketPlayOutWorldParticles(ep, true, (float) loc.getX(), (float) loc.getY(), (float) loc.getZ(), f, f, f, 0.0F, count, 0, 0);
        ((CraftPlayer)p).getHandle().playerConnection.sendPacket(packet);
    }

}