/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.api.items.attribute;

import net.minecraft.server.v1_12_R1.NBTTagList;
import org.bukkit.craftbukkit.v1_12_R1.inventory.CraftItemStack;
import org.bukkit.inventory.ItemStack;

import java.util.LinkedList;
import java.util.List;

/**
 * @author joethei
 * @version 1.0
 */
public class ItemAttributes {

    private NBTTagList modifiers;

    public ItemAttributes() {
        modifiers = new NBTTagList();
    }

    public void addModifier(AttributeModifier modifier) {
        if(modifiers != null) {
            modifiers.add(modifier.getNBT());
        }
    }

    public void removeModifier(AttributeModifier modifier) {
        if(modifiers != null) {
            for(int i = 0; i < modifiers.size(); i++) {
                if(modifiers.get(i).equals(modifier.getNBT())) {
                    modifiers.a(i, modifier.getNBT());
                }
            }
        }
    }

    public List<AttributeModifier> getModifiers() {
        if(modifiers != null) {
         List<AttributeModifier> modifiers = new LinkedList<>();
         for(int i= 0; i < this.modifiers.size(); i++) {
             modifiers.add(new AttributeModifier(this.modifiers.get(i)));
         }
         return modifiers;
        }
        return null;
    }

    public ItemStack apply(ItemStack item) {
        net.minecraft.server.v1_12_R1.ItemStack nmsItem = CraftItemStack.asNMSCopy(item);
        nmsItem.a("AttributeModifiers", this.modifiers);
        return CraftItemStack.asBukkitCopy(nmsItem);
    }

    public void getFromStack(ItemStack item) {
        net.minecraft.server.v1_12_R1.ItemStack nmsItem = CraftItemStack.asNMSCopy(item);
        assert nmsItem.getTag() != null;
        this.modifiers = nmsItem.getTag().getList("AttributeModifiers", 10);
        if(this.modifiers == null) this.modifiers = new NBTTagList();
    }
}