/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.api.player;

import java.util.LinkedList;
import java.util.List;

/**
 * @author joethei
 * @version 0.1
 */
public class SpectateManager {

    private static final List<Spectator> spectators = new LinkedList<>();

    public static Spectator get(CustomPlayer p) {
        for(Spectator spectator : spectators) {
            if(spectator.getPlayer().equals(p)) return spectator;
        }
        return null;
    }

    static void add(Spectator spectator) {
        if(!spectators.contains(spectator)) spectators.add(spectator);
    }

    static void remove(Spectator spectator) {
        if(spectators.contains(spectator)) spectators.remove(spectator);
    }

    public static boolean contains(CustomPlayer p) {
        return get(p) != null;
    }

}