/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.api.server;

import eu.univento.commons.server.ServerType;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.GameMode;

/**
 * @author joethei
 * @version 1.0
 */

public class ServerSettings {

    @Getter @Setter private static boolean debug;
    @Getter @Setter private static boolean mute;
    @Getter @Setter private static boolean game;
    @Getter private static ServerType serverType;
    @Getter @Setter private static GameMode gameMode;
    @Getter @Setter private static String gameState;
    @Getter @Setter private static int maxPlayers;

    public static void setServerType(ServerType serverType) {
        ServerSettings.serverType = serverType;
        ServerType.setServerType(serverType);
    }

    public static void setup(ServerType servertype, GameMode gameMode) {
        setServerType(servertype);
        setGameMode(gameMode);
    }

    public static boolean isLobby() {
        return serverType.equals(ServerType.LOBBY);
    }
}