/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.api.shop.entity;

import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.shop.ShopMenu;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractAtEntityEvent;
import org.bukkit.plugin.Plugin;

/**
 * @author joethei
 * @version 1.0
 */
class ShopEntity implements Listener{

    private LivingEntity entity;

    private EntityType type;
    private String name;
    private Location location;
    private ShopMenu menu;

    ShopEntity(Plugin plugin, EntityType type, String name, Location location, ShopMenu menu) {
        this.type = type;
        this.name = name;
        this.location = location;
        this.menu = menu;
        Bukkit.getPluginManager().registerEvents(this, plugin);
        spawn();
    }

    private void spawn() {
        if(entity == null) {
            LivingEntity entity = (LivingEntity) location.getWorld().spawnEntity(location, type);
            entity.setCustomName(name);
            entity.setCustomNameVisible(true);
            entity.setAI(false);

            this.entity = entity;
        }
    }

    public void despawn() {
        if(entity != null) {
            entity.remove();
        }
    }

    public EntityType getType() {
        return type;
    }

    public String getName() {
        return name;
    }

    public Location getLocation() {
        return location;
    }

    public ShopMenu getMenu() {
        return menu;
    }

    public LivingEntity getEntity() {
        return entity;
    }

    @EventHandler
    public void onPlayerInteractAtEntity(PlayerInteractAtEntityEvent e) {
        CustomPlayer p = CustomPlayer.getPlayer(e.getPlayer());
        Entity entity = e.getRightClicked();
        if(entity.getType() == type && name.equals(entity.getCustomName())) {
            e.setCancelled(true);
            p.openInventory(menu.getInventory());
        }
    }
}