/*
 *  Copyright (c) 2017 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.core.commands;

import eu.univento.commons.player.rank.Rank;
import eu.univento.commons.utils.Strings;
import eu.univento.core.api.command.Command;
import eu.univento.core.api.command.CommandArgs;
import eu.univento.core.api.hologram.HologramManager;

/**
 * @author joethei
 * @version 1.0
 */
public class HologramCommands {

    @Command(name = "hologram", description = "create awesome holograms", rank = Rank.Builder, inGameOnly = true)
    public void hologram(CommandArgs args) {
        if(args.length() == 0) {
            args.getPlayer().sendMessage("/hologram add <Name> <Nachricht>");
            args.getPlayer().sendMessage("/hologram remove <Name>");
            args.getPlayer().sendMessage("/hologram list");
        }
    }

    @Command(name = "hologram.list", description = "lists holograms", rank = Rank.Builder, inGameOnly = true)
    public void hologramList(CommandArgs args) {
        HologramManager.getHolograms().forEach((s, hologram) -> args.getPlayer().sendMessage("§6" + s +" | " + hologram.getLocation().toString()));
    }

    @Command(name = "hologram.add", description = "add holograms", rank = Rank.Builder, inGameOnly = true)
    public void hologramAdd(CommandArgs args) {
        if(args.length() > 2) {
            if (HologramManager.getHologram(args.getArg(1)) != null) {
                args.getPlayer().sendMessage("§cDieses Hologram gibt es schon");
            } else {
                String name = args.getArg(1);
                String[] text = Strings.remove(args.getArgs(), "add");
                text = Strings.remove(text, name);
                new eu.univento.core.api.hologram.Hologram(name, text, args.getPlayer().getLocation()).showAll();
            }
        }
    }

    @Command(name = "hologram.remove", description = "remove holograms", rank = Rank.Builder, inGameOnly = true)
    public void hologramRemove(CommandArgs args) {
        if(args.length() == 2) {
            if (HologramManager.getHologram(args.getArg(1)) != null) {
                HologramManager.getHologram(args.getArg(1)).destroy();
            } else args.getPlayer().sendMessage("§cDieses Hologram gibt es nicht");
        }
    }
}